package esercitazione6.binarytrees;

public class BinaryTreeVisits {

	
	public void printTree(BinaryTree t){
		this.printTreeWithTabs(t, 0, "Root");
	}
	
	private void printTabs(int tabs){
		for (int i = 0; i < tabs; i++) {
			System.out.print("\t");
		}	
	}
	
	private void printTreeWithTabs(BinaryTree t, Integer level, String label){
		
		if (t != null) {			
			this.printTabs(level);
			
			System.out.println( label + ":" + t.getValue() + " (d:" + t.getNodesInSubtree()  + ")");
			
			this.printTreeWithTabs(t.getLeftChild(), level+1, "Left");
			this.printTreeWithTabs(t.getRightChild(), level+1, "Right");			
			}
		}			
		
	public Integer setAndCountDescendants(BinaryTree t){
		
		Integer descendants = 0;
		
		if (t != null) {
			descendants = 1 + this.setAndCountDescendants(t.getLeftChild()) + this.setAndCountDescendants(t.getRightChild());
			t.setNodesInSubtree(descendants);
		}
		
		return descendants;
	}
	
 public void deleteLeafEqualToParent(BinaryTree t) {
		
		if (t != null) {
			if (t.isLeaf() && t.isLeftChild() && (t.getValue() == t.getParent().getValue())) {
				t.getParent().deleteLeftSubTree();
			}
			else {
				this.deleteLeafEqualToParent(t.getLeftChild());
				this.deleteLeafEqualToParent(t.getRightChild());
			}
		}
	}
	
 public void invert(BinaryTree bt){
		
		if (bt != null) {
			
			BinaryTree tmp = bt.getLeftChild();
			bt.setLeftChild(bt.getRightChild());
			bt.setRightChild(tmp);
			
			this.invert(bt.getLeftChild());
			this.invert(bt.getRightChild());
			
		}
  	}
}
